///Player
#include <Wire.h>

//Your player's ID
#define I2C_SLAVE_ADDRESS 1

//i2c commands
#define CMD_START_GAME 1
#define CMD_START_ROUND 2
#define CMD_TRUST 3
#define CMD_CHEAT 4
#define CMD_MINUS_COIN 5
#define CMD_0COIN 6
#define CMD_2COIN 7
#define CMD_3COIN 8
#define CMD_END_GAME 9
#define CMD_READY 10

//All the commands are single byte
#define PAYLOAD_SIZE 1

//Initializing
void setup()
{
  //Starting i2c and serial
  Wire.begin(I2C_SLAVE_ADDRESS);
  Serial.begin(9600); 
  Serial.print("Starting player ");
  Serial.println(I2C_SLAVE_ADDRESS);
  delay(100);               
  Wire.onRequest(requestEvents);
  Wire.onReceive(receiveEvents);
}

//variables to store received command and response to send
byte command = 0;
byte response = 0;

//Prepare response for sending
void setResponse(byte cmd)
{
  response = cmd;
  command = 0;//the command has been processed, so resetting it
}

//Play single roung
//Please implement your game strategy here
void playRound()
{
  setResponse( random(CMD_TRUST, CMD_CHEAT+1) );
}

//Single game
void game()
{
  while(true){
  	//waiting for new command
    while (command!=CMD_START_ROUND && command!=CMD_END_GAME);
    if (command == CMD_END_GAME){
      Serial.println("Ending game...");
      return;
    }
    //processing next round
    Serial.println("Starting new round...");
    playRound();
  }
}

//Main loop
void loop()
{
  //waiting for game start command
  while (command!=CMD_START_GAME);
  Serial.println("Starting new game...");
  setResponse(CMD_READY);
  //entering the game
  game();
}

//Sending response
void requestEvents()
{
  Serial.println(F("---> recieved request"));
  Serial.print(F("<---sending value : "));
  Serial.println(response);
  Wire.write(response);
}

//Reading received command
void receiveEvents(int numBytes)
{  
  Serial.print(F("---> recieved command: "));
  command = Wire.read();
  response = 0;
  Serial.println(command);
}